- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Ipopt::FilterLSAcceptor Class Reference

Filter line search. More...

`#include <IpFilterLSAcceptor.hpp>`

Inheritance diagram for Ipopt::FilterLSAcceptor:

[legend]
Collaboration diagram for Ipopt::FilterLSAcceptor:

[legend]
List of all members.

## Parameters for the filter algorithm. Names as in the paper
enum | CorrectorTypeEnum { NO_CORRECTOR = 0, AFFINE_CORRECTOR, PRIMAL_DUAL_CORRECTOR }
| enumeration for the corrector type More...
Number | eta_phi_
Number | delta_
Number | s_phi_
Number | s_theta_
Number | gamma_phi_
Number | gamma_theta_
Number | alpha_min_frac_
Index | max_soc_
| Maximal number of second order correction steps.
Number | kappa_soc_
| Required reduction in constraint violation before trying multiple second order correction steps .
Number | obj_max_inc_
| Maximal increase in objective function in orders of magnitute (log10).
CorrectorTypeEnum | corrector_type_
| Type of corrector steps that should be tried.
Number | corrector_compl_avrg_red_fact_
| parameter in heurstic that determines whether corrector step should be tried.
bool | skip_corr_if_neg_curv_
| Flag indicating whether the corrector should be skipped in an iteration in which negative curvature is detected.
bool | skip_corr_in_monotone_mode_
| Flag indicating whether the corrector should be skipped during the monotone mu mode.
Index | max_filter_resets_
| maximal allowed number of filter resets.
Index | filter_reset_trigger_
| interation counter trigger for filter reset.
## Public Member Functions
virtual bool | InitializeImpl (const OptionsList &options, const std::string &prefix)
| InitializeImpl - overloaded from AlgorithmStrategyObject.
virtual void | Reset ()
| Reset the acceptor.
virtual void | InitThisLineSearch (bool in_watchdog)
| Initialization for the next line search.
virtual void | PrepareRestoPhaseStart ()
| Method that is called before the restoration phase is called.
virtual Number | CalculateAlphaMin ()
| Method returning the lower bound on the trial step sizes.
virtual bool | CheckAcceptabilityOfTrialPoint (Number alpha_primal)
| Method for checking if current trial point is acceptable.
virtual bool | TrySecondOrderCorrection (Number alpha_primal_test, Number &alpha_primal, SmartPtr< IteratesVector > &actual_delta)
| Try a second order correction for the constraints.
virtual bool | TryCorrector (Number alpha_primal_test, Number &alpha_primal, SmartPtr< IteratesVector > &actual_delta)
| Try higher order corrector (for fast local convergence).
virtual char | UpdateForNextIteration (Number alpha_primal_test)
| Method for ending the current line search.
virtual void | StartWatchDog ()
| Method for setting internal data if the watchdog procedure is started.
virtual void | StopWatchDog ()
| Method for setting internal data if the watchdog procedure is stopped.
Constructors/Destructors
| FilterLSAcceptor (const SmartPtr< PDSystemSolver > &pd_solver)
| Constructor.
virtual | ~FilterLSAcceptor ()
| Default destructor.
Trial Point Accepting Methods. Used internally to check certain
acceptability criteria and used externally (by the restoration phase convergence check object, for instance)
bool | IsAcceptableToCurrentIterate (Number trial_barr, Number trial_theta, bool called_from_restoration=false) const
| Checks if a trial point is acceptable to the current iterate.
bool | IsAcceptableToCurrentFilter (Number trial_barr, Number trial_theta) const
| Checks if a trial point is acceptable to the current filter.
## Static Public Member Functions
static void | RegisterOptions (SmartPtr< RegisteredOptions > roptions)
| Methods for OptionsList.
## Private Member Functions
bool | IsFtype (Number alpha_primal_test)
| Method for checking if the current step size satisfies the f-type switching condition.
bool | ArmijoHolds (Number alpha_primal_test)
| Method for checking the Armijo condition, given a trial step size.
void | AugmentFilter ()
| Augment the filter used on the current values of the barrier objective function and the contraint violation.
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| FilterLSAcceptor (const FilterLSAcceptor &)
| Copy Constructor.
void | operator= (const FilterLSAcceptor &)
| Overloaded Equals Operator.
## Static Private Member Functions
static bool | Compare_le (Number lhs, Number rhs, Number BasVal)
| Check comparison "lhs <= rhs", using machine precision based on BasVal.
## Private Attributes
Filter | filter_
| Filter with entries.
Filter information
Number | theta_max_
| Upper bound on infeasibility.
Number | theta_max_fact_
| Upper bound on infeasibility.
Number | theta_min_
| Infeasibility switching bound.
Number | theta_min_fact_
| Upper bound on infeasibility.
Information related to watchdog procedure
Number | reference_theta_
| Constraint violation at the point with respect to which progress is to be made.
Number | reference_barr_
| Barrier objective function at the point with respect to which progress is to be made.
Number | reference_gradBarrTDelta_
| Barrier gradient transpose search direction at the point with respect to which progress is to be made.
Number | watchdog_theta_
| Constraint violation at reference point.
Number | watchdog_barr_
| Barrier objective function at reference point.
Number | watchdog_gradBarrTDelta_
| Barrier gradient transpose search direction at reference point.
Filter reset stuff
Number | last_rejection_due_to_filter_
| True, if last rejected was due to the filter.
Index | count_successive_filter_rejections_
| Counter of successive iterations in which filter was reason for last rejection.
Index | n_filter_resets_
| Counter for the filter resets done so far.
Strategy objective that are used
SmartPtr< PDSystemSolver > | pd_solver_

## Detailed Description

Filter line search.

This class implements the filter line search procedure.

Definition at line 23 of file IpFilterLSAcceptor.hpp.

## Member Enumeration Documentation

enum Ipopt::FilterLSAcceptor::CorrectorTypeEnum`[private]`

enumeration for the corrector type

Enumerator:

  NO_CORRECTOR |
  AFFINE_CORRECTOR |
  PRIMAL_DUAL_CORRECTOR |

Definition at line 207 of file IpFilterLSAcceptor.hpp.

## Constructor & Destructor Documentation

Ipopt::FilterLSAcceptor::FilterLSAcceptor | ( | const SmartPtr< PDSystemSolver > & | pd_solver | ) |

Constructor.

The PDSystemSolver object only needs to be provided (i.e. not NULL) if second order correction or corrector steps are to be used.

virtual Ipopt::FilterLSAcceptor::~FilterLSAcceptor | ( |  | ) | `[virtual]`

Default destructor.

Ipopt::FilterLSAcceptor::FilterLSAcceptor | ( | const FilterLSAcceptor & |  | ) | `[private]`

Copy Constructor.

## Member Function Documentation

virtual bool Ipopt::FilterLSAcceptor::InitializeImpl | ( | const OptionsList & | options,
|  | const std::string & | prefix |
| ) |  |  | `[virtual]`

InitializeImpl - overloaded from AlgorithmStrategyObject.

Implements Ipopt::BacktrackingLSAcceptor.

virtual void Ipopt::FilterLSAcceptor::Reset | ( |  | ) | `[virtual]`

Reset the acceptor.

This function should be called if all previous information should be discarded when the line search is performed the next time. For example, this method should be called if the barrier parameter is changed.

Implements Ipopt::BacktrackingLSAcceptor.

virtual void Ipopt::FilterLSAcceptor::InitThisLineSearch | ( | bool | in_watchdog | ) | `[virtual]`

Initialization for the next line search.

The flag in_watchdog indicates if we are currently in an active watchdog procedure.

Implements Ipopt::BacktrackingLSAcceptor.

virtual void Ipopt::FilterLSAcceptor::PrepareRestoPhaseStart | ( |  | ) | `[virtual]`

Method that is called before the restoration phase is called.

Here, we can set up things that are required in the termination test for the restoration phase, such as augmenting a filter.

Implements Ipopt::BacktrackingLSAcceptor.

virtual Number Ipopt::FilterLSAcceptor::CalculateAlphaMin | ( |  | ) | `[virtual]`

Method returning the lower bound on the trial step sizes.

If the backtracking procedure encounters a trial step size below this value after the first trial set, it swtiches to the (soft) restoration phase.

Implements Ipopt::BacktrackingLSAcceptor.

virtual bool Ipopt::FilterLSAcceptor::CheckAcceptabilityOfTrialPoint | ( | Number | alpha_primal | ) | `[virtual]`

Method for checking if current trial point is acceptable.

It is assumed that the delta information in ip_data is the search direction used in criteria. The primal trial point has to be set before the call.

Implements Ipopt::BacktrackingLSAcceptor.

virtual bool Ipopt::FilterLSAcceptor::TrySecondOrderCorrection | ( | Number | alpha_primal_test,
|  | Number & | alpha_primal,
|  | SmartPtr< IteratesVector > & | actual_delta |
| ) |  |  | `[virtual]`

Try a second order correction for the constraints.

If the first trial step (with incoming alpha_primal) has been reject, this tries up to max_soc_ second order corrections for the constraints. Here, alpha_primal_test is the step size that has to be used in the filter acceptance tests. On output actual_delta_ has been set to the step including the second order correction if it has been accepted, otherwise it is unchanged. If the SOC step has been accepted, alpha_primal has the fraction-to-the-boundary value for the SOC step on output. The return value is true, if a SOC step has been accepted.

Implements Ipopt::BacktrackingLSAcceptor.

virtual bool Ipopt::FilterLSAcceptor::TryCorrector | ( | Number | alpha_primal_test,
|  | Number & | alpha_primal,
|  | SmartPtr< IteratesVector > & | actual_delta |
| ) |  |  | `[virtual]`

Try higher order corrector (for fast local convergence).

In contrast to a second order correction step, which tries to make an unacceptable point acceptable by improving constraint violation, this corrector step is tried even if the regular primal-dual step is acceptable.

Implements Ipopt::BacktrackingLSAcceptor.

virtual char Ipopt::FilterLSAcceptor::UpdateForNextIteration | ( | Number | alpha_primal_test | ) | `[virtual]`

Method for ending the current line search.

When it is called, the internal data should be updates, e.g., the filter might be augmented. alpha_primal_test is the value of alpha that has been used for in the acceptence test ealier.

Implements Ipopt::BacktrackingLSAcceptor.

virtual void Ipopt::FilterLSAcceptor::StartWatchDog | ( |  | ) | `[virtual]`

Method for setting internal data if the watchdog procedure is started.

Implements Ipopt::BacktrackingLSAcceptor.

virtual void Ipopt::FilterLSAcceptor::StopWatchDog | ( |  | ) | `[virtual]`

Method for setting internal data if the watchdog procedure is stopped.

Implements Ipopt::BacktrackingLSAcceptor.

bool Ipopt::FilterLSAcceptor::IsAcceptableToCurrentIterate | ( | Number | trial_barr,
|  | Number | trial_theta,
|  | bool | called_from_restoration = `false` |
| ) |  |  | const

Checks if a trial point is acceptable to the current iterate.

bool Ipopt::FilterLSAcceptor::IsAcceptableToCurrentFilter | ( | Number | trial_barr,
|  | Number | trial_theta |
| ) |  |  | const

Checks if a trial point is acceptable to the current filter.

static void Ipopt::FilterLSAcceptor::RegisterOptions | ( | SmartPtr< RegisteredOptions > | roptions | ) | `[static]`

Methods for OptionsList.

Reimplemented from Ipopt::BacktrackingLSAcceptor.

void Ipopt::FilterLSAcceptor::operator= | ( | const FilterLSAcceptor & |  | ) | `[private]`

Overloaded Equals Operator.

bool Ipopt::FilterLSAcceptor::IsFtype | ( | Number | alpha_primal_test | ) | `[private]`

Method for checking if the current step size satisfies the f-type switching condition.

Here, we use the search direction stored in ip_data

bool Ipopt::FilterLSAcceptor::ArmijoHolds | ( | Number | alpha_primal_test | ) | `[private]`

Method for checking the Armijo condition, given a trial step size.

The test uses the search direction stored in ip_data, and the values of the functions at the trial point in ip_data.

void Ipopt::FilterLSAcceptor::AugmentFilter | ( |  | ) | `[private]`

Augment the filter used on the current values of the barrier objective function and the contraint violation.

static bool Ipopt::FilterLSAcceptor::Compare_le | ( | Number | lhs,
|  | Number | rhs,
|  | Number | BasVal |
| ) |  |  | `[static, private]`

Check comparison "lhs <= rhs", using machine precision based on BasVal.

## Member Data Documentation

Number Ipopt::FilterLSAcceptor::theta_max_`[private]`

Upper bound on infeasibility.

Definition at line 149 of file IpFilterLSAcceptor.hpp.

Number Ipopt::FilterLSAcceptor::theta_max_fact_`[private]`

Upper bound on infeasibility.

Definition at line 150 of file IpFilterLSAcceptor.hpp.

Number Ipopt::FilterLSAcceptor::theta_min_`[private]`

Infeasibility switching bound.

Definition at line 153 of file IpFilterLSAcceptor.hpp.

Number Ipopt::FilterLSAcceptor::theta_min_fact_`[private]`

Upper bound on infeasibility.

Definition at line 154 of file IpFilterLSAcceptor.hpp.

Number Ipopt::FilterLSAcceptor::eta_phi_`[private]`

Definition at line 181 of file IpFilterLSAcceptor.hpp.

Number Ipopt::FilterLSAcceptor::delta_`[private]`

Definition at line 183 of file IpFilterLSAcceptor.hpp.

Number Ipopt::FilterLSAcceptor::s_phi_`[private]`

Definition at line 185 of file IpFilterLSAcceptor.hpp.

Number Ipopt::FilterLSAcceptor::s_theta_`[private]`

Definition at line 187 of file IpFilterLSAcceptor.hpp.

Number Ipopt::FilterLSAcceptor::gamma_phi_`[private]`

Definition at line 189 of file IpFilterLSAcceptor.hpp.

Number Ipopt::FilterLSAcceptor::gamma_theta_`[private]`

Definition at line 191 of file IpFilterLSAcceptor.hpp.

Number Ipopt::FilterLSAcceptor::alpha_min_frac_`[private]`

Definition at line 193 of file IpFilterLSAcceptor.hpp.

Index Ipopt::FilterLSAcceptor::max_soc_`[private]`

Maximal number of second order correction steps.

Definition at line 195 of file IpFilterLSAcceptor.hpp.

Number Ipopt::FilterLSAcceptor::kappa_soc_`[private]`

Required reduction in constraint violation before trying multiple second order correction steps .

Definition at line 199 of file IpFilterLSAcceptor.hpp.

Number Ipopt::FilterLSAcceptor::obj_max_inc_`[private]`

Maximal increase in objective function in orders of magnitute (log10).

If the log10(barrier objective function) is increased more than this compared to the current point, the trial point is rejected.

Definition at line 204 of file IpFilterLSAcceptor.hpp.

CorrectorTypeEnum Ipopt::FilterLSAcceptor::corrector_type_`[private]`

Type of corrector steps that should be tried.

Definition at line 213 of file IpFilterLSAcceptor.hpp.

Number Ipopt::FilterLSAcceptor::corrector_compl_avrg_red_fact_`[private]`

parameter in heurstic that determines whether corrector step should be tried.

Definition at line 216 of file IpFilterLSAcceptor.hpp.

bool Ipopt::FilterLSAcceptor::skip_corr_if_neg_curv_`[private]`

Flag indicating whether the corrector should be skipped in an iteration in which negative curvature is detected.

Definition at line 219 of file IpFilterLSAcceptor.hpp.

bool Ipopt::FilterLSAcceptor::skip_corr_in_monotone_mode_`[private]`

Flag indicating whether the corrector should be skipped during the monotone mu mode.

Definition at line 222 of file IpFilterLSAcceptor.hpp.

Index Ipopt::FilterLSAcceptor::max_filter_resets_`[private]`

maximal allowed number of filter resets.

Definition at line 224 of file IpFilterLSAcceptor.hpp.

Index Ipopt::FilterLSAcceptor::filter_reset_trigger_`[private]`

interation counter trigger for filter reset.

If the successive number of iterations in which the last rejected step was due to the filter, and max_filter_resets is non-zero, then the filter is reset.

Definition at line 229 of file IpFilterLSAcceptor.hpp.

Number Ipopt::FilterLSAcceptor::reference_theta_`[private]`

Constraint violation at the point with respect to which progress is to be made.

Definition at line 236 of file IpFilterLSAcceptor.hpp.

Number Ipopt::FilterLSAcceptor::reference_barr_`[private]`

Barrier objective function at the point with respect to which progress is to be made.

Definition at line 239 of file IpFilterLSAcceptor.hpp.

Number Ipopt::FilterLSAcceptor::reference_gradBarrTDelta_`[private]`

Barrier gradient transpose search direction at the point with respect to which progress is to be made.

Definition at line 242 of file IpFilterLSAcceptor.hpp.

Number Ipopt::FilterLSAcceptor::watchdog_theta_`[private]`

Constraint violation at reference point.

Definition at line 244 of file IpFilterLSAcceptor.hpp.

Number Ipopt::FilterLSAcceptor::watchdog_barr_`[private]`

Barrier objective function at reference point.

Definition at line 246 of file IpFilterLSAcceptor.hpp.

Number Ipopt::FilterLSAcceptor::watchdog_gradBarrTDelta_`[private]`

Barrier gradient transpose search direction at reference point.

Definition at line 248 of file IpFilterLSAcceptor.hpp.

Filter Ipopt::FilterLSAcceptor::filter_`[private]`

Filter with entries.

Definition at line 252 of file IpFilterLSAcceptor.hpp.

Number Ipopt::FilterLSAcceptor::last_rejection_due_to_filter_`[private]`

True, if last rejected was due to the filter.

Definition at line 257 of file IpFilterLSAcceptor.hpp.

Index Ipopt::FilterLSAcceptor::count_successive_filter_rejections_`[private]`

Counter of successive iterations in which filter was reason for last rejection.

Definition at line 260 of file IpFilterLSAcceptor.hpp.

Index Ipopt::FilterLSAcceptor::n_filter_resets_`[private]`

Counter for the filter resets done so far.

Definition at line 262 of file IpFilterLSAcceptor.hpp.

SmartPtr<PDSystemSolver> Ipopt::FilterLSAcceptor::pd_solver_`[private]`

Definition at line 267 of file IpFilterLSAcceptor.hpp.

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Ipopt-3.2.1/Ipopt/src/Algorithm/IpFilterLSAcceptor.hpp